<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<title>LibSylph: Sylph/IO/BufferedInputStream.h Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.8 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="classes.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
    </ul>
  </div>
<h1>Sylph/IO/BufferedInputStream.h</h1><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment"> * LibSylph Class Library</span>
<a name="l00003"></a>00003 <span class="comment"> * Copyright (C) 2009 Frank "SeySayux" Erens &lt;seysayux@gmail.com&gt;</span>
<a name="l00004"></a>00004 <span class="comment"> *</span>
<a name="l00005"></a>00005 <span class="comment"> * This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment"> * modify it under the terms of the LibSylph Pulbic License as published</span>
<a name="l00007"></a>00007 <span class="comment"> * by the LibSylph Developers; either version 1.0 of the License, or</span>
<a name="l00008"></a>00008 <span class="comment"> * (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment"> *</span>
<a name="l00010"></a>00010 <span class="comment"> * This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment"> * but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment"> * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the LibSylph</span>
<a name="l00013"></a>00013 <span class="comment"> * Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment"> *</span>
<a name="l00015"></a>00015 <span class="comment"> * You should have received a copy of the LibSylph Public License</span>
<a name="l00016"></a>00016 <span class="comment"> * along with this Library, if not, contact the LibSylph Developers.</span>
<a name="l00017"></a>00017 <span class="comment"> *</span>
<a name="l00018"></a>00018 <span class="comment"> * Created on 30 juni 2009, 12:07</span>
<a name="l00019"></a>00019 <span class="comment"> */</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef BUFFEREDINPUTSTREAM_H_</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define BUFFEREDINPUTSTREAM_H_</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="preprocessor">#include "InputStream.h"</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include "../Core/Primitives.h"</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 SYLPH_BEGIN_NAMESPACE
<a name="l00028"></a>00028 SYLPH_PUBLIC
<a name="l00029"></a>00029 <span class="keyword">class </span>BufferedInputStream : <span class="keyword">public</span> InputStream {
<a name="l00030"></a>00030 <span class="keyword">public</span>:
<a name="l00031"></a>00031     BufferedInputStream(InputStream&amp; _orig, <span class="keywordtype">size_t</span> bufsize = 1024);
<a name="l00032"></a>00032     <span class="keyword">virtual</span> ~BufferedInputStream();
<a name="l00033"></a>00033 
<a name="l00034"></a>00034     fsize_t available() <span class="keyword">const</span>;
<a name="l00035"></a>00035     <span class="keywordtype">bool</span> eof() <span class="keyword">const</span>;
<a name="l00036"></a>00036     <span class="keywordtype">bool</span> markSupported()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00037"></a>00037     <span class="keywordtype">void</span> mark(fsize_t);
<a name="l00038"></a>00038     fsize_t skip(fsize_t);
<a name="l00039"></a>00039     <span class="keywordtype">void</span> reset();
<a name="l00040"></a>00040 
<a name="l00041"></a>00041     InputStream&amp; operator&gt;&gt;(byte&amp;);
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="keyword">private</span>:
<a name="l00044"></a>00044     <span class="keywordtype">void</span> readNext();
<a name="l00045"></a>00045     InputStream&amp; orig;
<a name="l00046"></a>00046     Array&lt;byte&gt; buffer;
<a name="l00047"></a>00047     <span class="keywordtype">size_t</span> used;
<a name="l00048"></a>00048     idx_t currentIdx;
<a name="l00049"></a>00049     idx_t markpos;
<a name="l00050"></a>00050     idx_t marklen;
<a name="l00051"></a>00051 };
<a name="l00052"></a>00052 SYLPH_END_NAMESPACE
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 <span class="preprocessor">#endif  </span><span class="comment">/* BUFFEREDINPUTSTREAM_H_ */</span>
<a name="l00055"></a>00055 
</pre></div></div>
<hr size="1" class="unhidden"><address style="text-align: right;"><small>
Documentation for LibSylph by Doxygen
</body>
</html>
